﻿using UnityEngine;
using UnityEngine.UI;
using HarmonyLib;
using System.Collections.Generic;
using System;
using System.IO;
using System.Linq;
using UnityEngine.AzureSky;
using Steamworks;

public class BatteryIndicator : Mod {
    private Harmony harmony;

    public void Start() {
        harmony = new Harmony("com.nimachris.BatteryIndicator");
        harmony.PatchAll();
        Debug.Log("Mod BatteryIndicator has been loaded!");
    }

    public void OnModUnload() {
        harmony.UnpatchAll();
        Debug.Log("Mod BatteryIndicator has been unloaded!");
    }
}

[HarmonyPatch(typeof(Battery), "OnIsRayed")]
public class Patch_BatteryRayed {
    public static ItemInstance batteryInstance;
    static void Prefix(ref Battery __instance) {
        batteryInstance = Traverse.Create(__instance).Field("batteryInstance").GetValue<ItemInstance>();
    }
    static void Postfix() {
        batteryInstance = null;
    }
}

[HarmonyPatch(typeof(DisplayTextManager), "ShowText", new Type[] { typeof(string), typeof(KeyCode), typeof(int), typeof(int), typeof(bool) })]
public class Patch_BatteryDisplayText {
    static void Prefix(ref string text) {
        if (Patch_BatteryRayed.batteryInstance != null)
            text += "\n" + Patch_BatteryRayed.batteryInstance.Uses * 100 / Patch_BatteryRayed.batteryInstance.baseItem.MaxUses + "%";
    }
}
